/////////////////////////////////////////////////////////////////////////////
// PatriotTabbar.cpp : Cve[V t@C
//
/////////////////////////////////////////////////////////////////////////////
#include "stdafx.h"
#include "patriot.h"
#include "patriotGlobal.h"
#include "PatriotTabbar.h"
#include "MainFrm.h"
#include "PatriotView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

//#include <shlobj.h>
//#include <intshcut.h>
/////////////////////////////////////////////////////////////////////////////
// CPatriotTabbar

CPatriotTabbar::CPatriotTabbar()
	: m_Font()
	, menuContext()
	, m_Images()
	, m_crSelColor(0)
	, m_crUnselColor(0)
	, m_SelFont()
	, m_UnselFont()
	, posClicked(0,0)
	, m_TabSize(0,0)
	, m_ClickedTab(0)
	, m_DragedTab(0)
	, pTabs(0)
	, m_oDropTarget()
{
}

CPatriotTabbar::~CPatriotTabbar()
{
	m_SelFont.DeleteObject();
	m_UnselFont.DeleteObject();
}

BEGIN_MESSAGE_MAP(CPatriotTabbar, CTabCtrl)
	//{{AFX_MSG_MAP(CPatriotTabbar)
	ON_NOTIFY_REFLECT(TCN_SELCHANGE, OnSelchange)
	ON_WM_MOUSEWHEEL()
	ON_WM_MBUTTONDOWN()
	ON_WM_LBUTTONDBLCLK()
	ON_WM_CREATE()
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_WM_MOUSEMOVE()
	ON_WM_DESTROY()
	ON_WM_RBUTTONDOWN()
	ON_WM_RBUTTONUP()
	ON_COMMAND(ID_FILE_CLOSEEXCEPT, OnFileCloseexcept)
	ON_COMMAND(ID_FILE_CLOSELEFT, OnFileCloseleft)
	ON_COMMAND(ID_FILE_CLOSERIGHT, OnFileCloseright)
	//}}AFX_MSG_MAP
	ON_WM_ERASEBKGND()
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPatriotTabbar \bh

/// tHgݒ
void CPatriotTabbar::SetFonts(int nSelWeight, BOOL bSelItalic, BOOL bSelUnderline
						  , int nUnselWeight, BOOL bUnselItalic, BOOL bUnselUnderline)
{
	// tHgJ
	m_SelFont.DeleteObject();
	m_UnselFont.DeleteObject();

	// ݂̃tHg擾
	LOGFONT lFont;
	CFont *pFont = &m_Font;// GetFont();
	if (pFont) {
		pFont->GetLogFont(&lFont);
	} else {
		NONCLIENTMETRICS ncm;
		ncm.cbSize = sizeof(NONCLIENTMETRICS);
		VERIFY(SystemParametersInfo(SPI_GETNONCLIENTMETRICS, sizeof(NONCLIENTMETRICS), &ncm, 0));
		lFont = ncm.lfMessageFont;
	}
	// I𒆂̃^uptHg
	lFont.lfWeight	  = (nSelWeight) ? FW_BOLD : FW_NORMAL;
	lFont.lfItalic	  = (BYTE)bSelItalic;		//+++ cast.
	lFont.lfUnderline = (BYTE)bSelUnderline;	//+++ cast.
	m_SelFont.CreateFontIndirect(&lFont);

	// IĂȂ̃^uptHg
	lFont.lfWeight	  = (nUnselWeight) ? FW_BOLD : FW_NORMAL;
	lFont.lfItalic	  = (BYTE)bUnselItalic; 	//+++ cast.
	lFont.lfUnderline = (BYTE)bUnselUnderline;	//+++ cast.
	m_UnselFont.CreateFontIndirect(&lFont);

	SetFont((nSelWeight < nUnselWeight) ? &m_SelFont : &m_UnselFont);
}

/// C[W̃[h
void CPatriotTabbar::LoadIcons()
{
	CString strBmpPath = g_Options.strAppPath + _T("\\res\\tab.bmp");
	HBITMAP hBitmap = ( HBITMAP )::LoadImage( NULL, strBmpPath, IMAGE_BITMAP, 0, 0, LR_LOADFROMFILE );
	CBitmap objBitmap;
	objBitmap.Attach(hBitmap);

	m_Images.Create( 12, 12, ILC_MASK | ILC_COLOR32, 0, 7 );
	m_Images.Add( &objBitmap, RGB(255, 0, 255) );

	SetImageList( &m_Images );
	SetPadding( (1, 1) );
}

/// j[Ƀ`FbN
void CPatriotTabbar::SetMenuCheck(UINT nID)
{
	BOOL bFlag = FALSE;
	CPatriotView* pView = (CPatriotView*)pTabs->pView[m_ClickedTab];
	if (pTabs->pView[m_ClickedTab] != NULL) {
		// ^u
		switch(nID){
		case ID_VIEW_AUTOREFRESH:
			bFlag = pView->bAutoRefresh;
			break;
		case ID_TOOL_ANTIPOPUP:
			bFlag = pView->bAntiPopup;
			break;
		case ID_TOOL_NEWWINDOW:
			bFlag = pView->bNavigateLock;
			break;
		case ID_TOOL_ACTIVETAB:
			bFlag = pView->bTabLock;
			break;
		case ID_TOOL_LOADIMAGE:
			bFlag = pView->bLoadImage;
			break;
		case ID_TOOL_LOADBGM:
			bFlag = pView->bLoadBgm;
			break;
		case ID_TOOL_LOADMOVIE:
			bFlag = pView->bLoadVideo;
			break;
		case ID_TOOL_RUNSCRIPT:
			bFlag = pView->bRunScript;
			break;
		case ID_TOOL_RUNJAVA:
			bFlag = pView->bRunJava;
			break;
		case ID_TOOL_LOADACTIVEX:
			bFlag = pView->bLoadActivex;
			break;
		case ID_TOOL_RUNACTIVEX:
			bFlag = pView->bRunActivex;
			break;
		case ID_TOOL_USEDLG:
			bFlag = pView->bUseDlg;
			break;
		}
	}
	menuContext.CheckMenuItem( nID, MF_BYCOMMAND | bFlag ? MF_CHECKED : MF_UNCHECKED );
}

/// j[ڂ̎s
void CPatriotTabbar::MouseEvents(int Index, CPoint point)
{
	TCHITTESTINFO info = {0};
	info.pt 	 = point;
	info.flags	 = TCHT_ONITEM;
	m_ClickedTab = HitTest(&info);

	if (m_ClickedTab < 0 || m_ClickedTab >= pTabs->count) {
		return;
	}
	switch(Index){
	case 0://Ȃ
		break;
	case 1://j[
		if ( menuContext == NULL ) {
			if (g_Options.UseCustomTabmenu) { // Ǝ
				menuContext.CreatePopupMenu();
				CMainFrame* pFrame = (CMainFrame*)AfxGetMainWnd();
				pFrame->CreateCustomMenu(&menuContext, _T("Tabbar") );
			}
			else{ // ftHg
				menuContext.LoadMenu(IDR_TABBAR);
			}
		}

		// j[̃`FbN}[NXV
		SetMenuCheck(ID_VIEW_AUTOREFRESH);
		SetMenuCheck(ID_TOOL_ANTIPOPUP);
		SetMenuCheck(ID_TOOL_NEWWINDOW);
		SetMenuCheck(ID_TOOL_ACTIVETAB);
		SetMenuCheck(ID_TOOL_LOADIMAGE);
		SetMenuCheck(ID_TOOL_LOADBGM);
		SetMenuCheck(ID_TOOL_LOADMOVIE);
		SetMenuCheck(ID_TOOL_RUNSCRIPT);
		SetMenuCheck(ID_TOOL_RUNJAVA);
		SetMenuCheck(ID_TOOL_LOADACTIVEX);
		SetMenuCheck(ID_TOOL_RUNACTIVEX);
		SetMenuCheck(ID_TOOL_USEDLG);

		ClientToScreen( &point );
		menuContext.GetSubMenu(0)->TrackPopupMenu(TPM_LEFTALIGN | TPM_LEFTBUTTON, point.x, point.y, this, NULL);
		break;
	case 2://
		pTabs->pView[m_ClickedTab]->SendMessage(WM_COMMAND, ID_FILE_CLOSE);
		break;
	case 3://XV
		pTabs->pView[m_ClickedTab]->SendMessage(WM_COMMAND, ID_VIEW_REFRESH);
		break;
	case 4://VtgbN
		pTabs->pView[m_ClickedTab]->SendMessage(WM_COMMAND, ID_TOOL_NEWWINDOW);
		break;
	case 5://^ubN
		pTabs->pView[m_ClickedTab]->SendMessage(WM_COMMAND, ID_TOOL_ACTIVETAB);
		break;
	case 6://URL}~ɒǉ
		pTabs->pView[m_ClickedTab]->SendMessage(WM_COMMAND, ID_TOOL_ADDCLOSEURL);
		break;
	case 7://^Cg}~ɒǉ
		pTabs->pView[m_ClickedTab]->SendMessage(WM_COMMAND, ID_TOOL_ADDCLOSETITLE);
		break;
	case 8://SẴ^u
		AfxGetMainWnd()->SendMessage(WM_COMMAND, ID_FILE_CLOSEALL);
		break;
	case 9://̃^uȊO
		SendMessage(WM_COMMAND, ID_FILE_CLOSEEXCEPT);
		break;
	case 10://̃^u荶
		SendMessage(WM_COMMAND, ID_FILE_CLOSELEFT);
		break;
	case 11://̃^uE
		SendMessage(WM_COMMAND, ID_FILE_CLOSERIGHT);
		break;
	}
}

/// IvVǂݍ
void CPatriotTabbar::LoadOptions()
{
	// F̎w
	m_crSelColor   = g_Options.TabSelFontColor;
	m_crUnselColor = g_Options.TabFontColor;
	SetFonts(g_Options.TabSelFontB, g_Options.TabSelFontI, g_Options.TabSelFontU
			 , g_Options.TabFontB, g_Options.TabFontI, g_Options.TabFontU);

	ModifyStyle(
			((!g_Options.TabButton )	? TCS_BUTTONS | TCS_FLATBUTTONS | TCS_HOTTRACK : TCS_TABS)
		|	((!g_Options.TabMulti  )	? TCS_MULTILINE : TCS_SINGLELINE)
		|	((g_Options.TabWidth == 0)	? TCS_FIXEDWIDTH : NULL)
		,
			((g_Options.TabButton)	? TCS_BUTTONS | TCS_FLATBUTTONS | TCS_HOTTRACK : TCS_TABS)
		|	((g_Options.TabMulti)	? TCS_MULTILINE : TCS_SINGLELINE)
		|	((g_Options.TabWidth>0) ? TCS_FIXEDWIDTH : NULL));
	// Œ蕝
	m_TabSize = CSize(g_Options.TabWidth, g_Options.TabUnder ? 20 : 18);
	SetItemSize(m_TabSize);
}

/// 2
BOOL CPatriotTabbar::PreCreateWindow(CREATESTRUCT& cs)
{
	cs.style|=TCS_OWNERDRAWFIXED | TCS_FOCUSNEVER
			| ((g_Options.TabMulti ) ? TCS_MULTILINE : TCS_SINGLELINE)
			| ((g_Options.TabButton) ? TCS_BUTTONS | TCS_FLATBUTTONS | TCS_HOTTRACK : TCS_TABS)
			| ((g_Options.TabUnder ) ? TCS_BOTTOM : NULL);
	return CTabCtrl::PreCreateWindow(cs);
}

/// ^u̕`
void CPatriotTabbar::DrawItem(LPDRAWITEMSTRUCT lpDrawItemStruct)
{
	CRect rect;

	CDC* pDC = CDC::FromHandle(lpDrawItemStruct->hDC);
	if (!pDC) {
		return;
	}
	int nSavedDC = pDC->SaveDC();

	if (!g_Options.TabButton && !g_Options.TabUnder) {
		// ςȐ
		GetClientRect(rect);
		CPen  Pen;
		CPen* oldPen;
		Pen.CreatePen( PS_SOLID, 2, pDC->GetBkColor() );
		oldPen = pDC->SelectObject(&Pen);
		pDC->MoveTo( rect.left, rect.bottom - 1 );
		pDC->LineTo( rect.right, rect.bottom - 1 );

		pDC->SelectObject(oldPen);
	}

	// ̈擾
	rect = lpDrawItemStruct->rcItem;
	// For some bizarre reason the rcItem you get extends above the actual
	// drawing area. We have to work around this  _T("feature") .
	int nSysCyEdge = ::GetSystemMetrics(SM_CYEDGE);
	rect.top += nSysCyEdge;

	// CfbNXȂǂ擾
	int nTabIndex = lpDrawItemStruct->itemID;
	if (nTabIndex < 0) {
		ASSERT(1);
		return;
	}
	//this->GetItemRect(nTabIndex, &rect);
	BOOL bSelected = (lpDrawItemStruct->itemState == ODS_SELECTED);

	// 
	TCHAR 		label[64];
	TC_ITEM 	tci = {0};
	tci.mask 		= TCIF_TEXT | TCIF_IMAGE;
	tci.pszText 	= label;
	tci.cchTextMax 	= 64;
	if (!GetItem(nTabIndex, &tci)) {
		return;
	}

	// wi
	int oldBkMode = pDC->SetBkMode(TRANSPARENT);
	rect.top	-= 2;
	rect.bottom += 2;

	if (bSelected){// I
		if (g_Options.TabButton && (UINT)g_Options.TabSelBackColor == ::GetSysColor(COLOR_BTNFACE)) {
			// ftHg
			COLORREF crTxt = pDC->SetTextColor( ::GetSysColor(COLOR_BTNFACE) );
			COLORREF crBk  = pDC->SetBkColor( ::GetSysColor(COLOR_BTNHILIGHT) );
			pDC->FillRect(rect, pDC->GetHalftoneBrush());
			pDC->SetBkColor(crBk);
			pDC->SetTextColor(crTxt);
		} else {
			pDC->FillSolidRect(rect, g_Options.TabSelBackColor);//::GetSysColor(COLOR_BTNFACE)
		}
	} else /*if ((UINT)g_Options.TabBackColor != ::GetSysColor(COLOR_BTNFACE))*/ {
		pDC->FillSolidRect(rect, g_Options.TabBackColor);
	}
	rect.top += 2;


	// Draw image
	CImageList* pImageList = GetImageList();
	if (pImageList && tci.iImage >= 0) {
		rect.left +=2;//pDC->GetTextExtent(_T(" ")).cx; 	// Margin
		// Get height of image so we
		IMAGEINFO info;
		pImageList->GetImageInfo(tci.iImage, &info);
		int nYpos = 0;
		if (g_Options.TabButton) {
			nYpos = rect.top-1;
		} else if (g_Options.TabUnder) {
			nYpos = (bSelected) ? rect.top+4 : rect.top;
		} else {
			nYpos = (bSelected) ? rect.top+3 : rect.top-1;
		}
		POINT pos = {rect.left, nYpos};
		pImageList->Draw(pDC, tci.iImage, pos, ILD_TRANSPARENT);
		rect.left += info.rcImage.right - info.rcImage.left + 1;
	} else if (!g_Options.TabButton) {
		rect.left += 6;
	} else {
		rect.left += 3;
	}

	UINT nDrawFormat;
	if (bSelected) {
		nDrawFormat = DT_SINGLELINE | DT_VCENTER | DT_LEFT | DT_NOPREFIX;

		rect.top	-= nSysCyEdge;
		rect.bottom -= 1;

		pDC->SetTextColor(m_crSelColor);
		pDC->SelectObject(&m_SelFont);
	} else {
		nDrawFormat = DT_SINGLELINE | DT_BOTTOM | DT_LEFT | DT_NOPREFIX;

		if (g_Options.TabUnder && !g_Options.TabButton) { // i
			rect.top	-= 5;
			rect.bottom -= 5;
		} else if (g_Options.TabButton) { // {^
			rect.top	-= nSysCyEdge;
			rect.bottom -= 2;
		} else {
			rect.bottom -= 2;
		}

		pDC->SetTextColor(m_crUnselColor);
		pDC->SelectObject(&m_UnselFont);
	}
	pDC->DrawText(label, rect, nDrawFormat);

	pDC->SetBkMode(oldBkMode);
	pDC->RestoreDC(nSavedDC);
}
/////////////////////////////////////////////////////////////////////////////
// CPatriotTabbar bZ[W nh

void CPatriotTabbar::OnSelchange(NMHDR* pNMHDR, LRESULT* pResult)
{
	CMainFrame* pFrame = (CMainFrame*)AfxGetMainWnd();

	pFrame->SetTab(GetCurSel());
	*pResult = 0;
}

BOOL CPatriotTabbar::OnMouseWheel(UINT nFlags, short zDelta, CPoint pt)
{ // zC[̉]
	if (g_Options.TabUseWheel) {
		//AfxMessageBox(ItoStr(abs(zDelta)));
		if (zDelta > 0) {
			AfxGetMainWnd()->SendMessage( WM_COMMAND, ID_WINDOW_BACKTAB );
		} else {
			AfxGetMainWnd()->SendMessage( WM_COMMAND, ID_WINDOW_NEXTTAB );
		}
	}
	return CTabCtrl::OnMouseWheel(nFlags, zDelta, pt);
}

void CPatriotTabbar::OnMButtonDown(UINT nFlags, CPoint point)
{ // zC[NbN
	if (nFlags & MK_SHIFT) {
		MouseEvents(g_Options.TabSwClick, point);
	} else {
		MouseEvents(g_Options.TabWlClick, point);
	}
//	CTabCtrl::OnMButtonDown(nFlags, point);
}

void CPatriotTabbar::OnRButtonDown(UINT nFlags, CPoint point)
{ // +E
	if (nFlags & MK_LBUTTON) {
		MouseEvents(g_Options.TabLrClick, point);
	} else if (nFlags & MK_SHIFT) {
		MouseEvents(g_Options.TabSrClick, point);
	}
	CTabCtrl::OnRButtonDown(nFlags, point);
}

void CPatriotTabbar::OnRButtonUp(UINT nFlags, CPoint point)
{ // ENbN
	if (!(nFlags & MK_LBUTTON) && !(nFlags & MK_SHIFT)) {
		MouseEvents(g_Options.TabRtClick, point);
	}
	CTabCtrl::OnRButtonUp(nFlags, point);
}

void CPatriotTabbar::OnLButtonDblClk(UINT nFlags, CPoint point)
{ // _uNbN
	MouseEvents( g_Options.TabDbClick, point );
	CTabCtrl::OnLButtonDblClk( nFlags, point );
}

void CPatriotTabbar::OnLButtonDown(UINT nFlags, CPoint point)
{ // hbOJn
	posClicked = point;
	TCHITTESTINFO info = {0};
	info.pt    = point;
	info.flags = TCHT_ONITEM;

	m_DragedTab = HitTest(&info);

	if (nFlags & MK_SHIFT) { // shift
		MouseEvents(g_Options.TabSlClick , point);
		return;
	}
	if (nFlags == MK_LBUTTON) {
		CMainFrame* pFrame = (CMainFrame*)AfxGetMainWnd();
		pFrame->SetTab(m_DragedTab);
		return;
	}
	CTabCtrl::OnLButtonDown(nFlags, point);
}
void CPatriotTabbar::OnLButtonUp(UINT nFlags, CPoint point)
{ // hbOI
	m_DragedTab = -1;
	CTabCtrl::OnLButtonUp(nFlags, point);
}

int CPatriotTabbar::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CTabCtrl::OnCreate(lpCreateStruct) == -1){
		return -1;
	}

	CSize	size;
	// w肵傫̃tHg쐬
	CString strFont = AfxGetApp()->GetProfileString( _T("Tab"), _T("FontFace"), _T("MS UI Gothic") );

	CClientDC dc(this);
	m_Font.DeleteObject();	// U폜
	m_Font.CreatePointFont( g_Options.TabFontSize * 10, strFont, NULL);
	CFont* pOldFont = dc.SelectObject(&m_Font);
	SetFont(&m_Font, TRUE);
	dc.SelectObject(pOldFont);	// tHgɖ߂

	if (g_Options.TabWidth > 0) {
		SetMinTabWidth( g_Options.TabWidth );
	}
	// F̎w
	SetFonts(g_Options.TabSelFontB, g_Options.TabSelFontI, g_Options.TabSelFontU
			 , g_Options.TabFontB, g_Options.TabFontI, g_Options.TabFontU);
	m_crSelColor   = g_Options.TabSelFontColor;
	m_crUnselColor = g_Options.TabFontColor;

	LoadIcons();
	SetExtendedStyle(TCS_EX_FLATSEPARATORS);
	// OLE
	// Ver1.0.05 ^uOւ̃hbvɑΉ邽 Rebar o^
	m_oDropTarget.m_nParent = OLE_TARGET_TABBAR;
	m_oDropTarget.Register( GetParent()/*this*/);
	// ToolTip
	EnableToolTips(TRUE);
	GetToolTips()->ModifyStyle(NULL, TTS_ALWAYSTIP | TTS_NOPREFIX);
	GetToolTips()->SetMaxTipWidth(640);
	return 0;
}

void CPatriotTabbar::OnDestroy()
{
	CTabCtrl::OnDestroy();
	SetImageList(NULL);
	m_Images.DeleteImageList();
	menuContext.DestroyMenu();
}

BOOL CPatriotTabbar::OnEraseBkgnd(CDC* pDC)
{//
	CWnd* pParent = GetParent();
	ASSERT_VALID(pParent);
	CPoint pt(0, 0);
	MapWindowPoints(pParent, &pt, 1);
	pt = pDC->OffsetWindowOrg(pt.x, pt.y);
	LRESULT lResult = pParent->SendMessage(WM_ERASEBKGND, (WPARAM)pDC->m_hDC, 0L);
	pDC->SetWindowOrg(pt.x, pt.y);
	return lResult != 0;	//+++ add != 0.
}

void CPatriotTabbar::OnMouseMove(UINT nFlags, CPoint point)
{ // hbO
	if (!(nFlags & MK_LBUTTON)) {
		m_DragedTab=-1;
	}

	TCHITTESTINFO info = {0};
	info.pt 	= point;
	info.flags	= TCHT_ONITEM;
	int   Index = HitTest(&info);

	if (!(nFlags & MK_LBUTTON) && Index >= 0) {
		// GetToolTips()->Create(this , TTS_ALWAYSTIP|TTS_NOPREFIX);
		CRect		rect;
		GetItemRect(Index, rect);
		CString		strText = pTabs->pView[Index]->GetLocationName() + _T("\n") + pTabs->pView[Index]->GetLocationURL();
		GetToolTips()->AddTool( this, strText, rect , 2/*Index+1*/);
	}

	if (m_DragedTab >= 0 && (abs(point.x-posClicked.x) >= 2 || abs(point.y - posClicked.y) >= 2)) {
		//	f[^\[XCX^X
		COleDataSource 	dataSource;
		CString			strURL	 = pTabs->pView[m_DragedTab]->GetLocationURL();
		CString			strTitle = GetValidFilename(pTabs->pView[m_DragedTab]->GetLocationName());

		// t@Co^
		::RegistOLEFileContents(dataSource, strTitle, strURL);

		// o^
		HGLOBAL		hText		= CreateOLEText(strURL);
		CLIPFORMAT	CF_SHELLURL = static_cast<CLIPFORMAT>(::RegisterClipboardFormat(CFSTR_INETURL/*+++CFSTR_SHELLURL*/));
		dataSource.CacheGlobalData(CF_SHELLURL , hText);
		dataSource.CacheGlobalData(BURA_CF_TEXT, hText);

		// ^ũCfbNXo^
		HGLOBAL hTabIndex 	= ::GlobalAlloc(GMEM_SHARE | GMEM_ZEROINIT, sizeof(int));
		int* 	pIndex 		= (int*)::GlobalLock(hTabIndex);
		*pIndex = m_DragedTab;
		::GlobalUnlock(hTabIndex);

		CLIPFORMAT CF_BURATABINDEX = static_cast<CLIPFORMAT>(::RegisterClipboardFormat(_T("Bura.TabIndex")));
		dataSource.CacheGlobalData( CF_BURATABINDEX, hTabIndex );

		// DnDJn
		/*+++ DROPEFFECT result =*/ dataSource.DoDragDrop( DROPEFFECT_COPY | DROPEFFECT_MOVE | DROPEFFECT_LINK );
	}
	CTabCtrl::OnMouseMove(nFlags, point);
}

/// t@C̃hbv
void CPatriotTabbar::OnDropFiles(HDROP hDropInfo)
{
	CPoint 		point;
	DragQueryPoint(hDropInfo, &point);
	// Ver1.0.09 WbN̐
	AfxGetMainWnd()->MapWindowPoints( this, &point, 1 );

	TCHITTESTINFO info = {0};
	info.pt 	 = point;
	info.flags	 = TCHT_ONITEM;

	int oldIndex = GetCurSel();
	int newIndex = HitTest( &info );

	if (newIndex == -1) {// ^ůO
		return;
	}

	AfxGetMainWnd()->PostMessage( WM_INSERTTAB, oldIndex, newIndex );
	CTabCtrl::OnDropFiles(hDropInfo);
}

BOOL CPatriotTabbar::OnCommand(WPARAM wParam, LPARAM lParam)
{
	try { // j[
		if (m_ClickedTab >= 0 && m_ClickedTab < pTabs->count && wParam != ID_FILE_CLOSEEXCEPT && wParam != ID_FILE_CLOSELEFT && wParam != ID_FILE_CLOSERIGHT) {
			if (wParam == ID_FILE_CLOSE) {
				pTabs->pView[m_ClickedTab]->PostMessage( WM_COMMAND, wParam );
				return TRUE;
			}
			LRESULT result = pTabs->pView[m_ClickedTab]->SendMessage( WM_COMMAND, wParam );
			if (result == 0) {
				AfxGetMainWnd()->PostMessage( WM_COMMAND, wParam );
			}
			return TRUE;
		}
	} catch(...) {
		AfxMessageBox("Err:OnCommand (Index"+ItoStr(m_ClickedTab));
	}
	return CTabCtrl::OnCommand(wParam, lParam);
}

/// ̃^uȊO
void CPatriotTabbar::OnFileCloseexcept()
{
	if (g_Options.bAlertCloseExcept) {
		int nResult = AfxMessageBox( _T("̃^uȊO܂B"), MB_OKCANCEL | MB_ICONQUESTION, 0);
		if (nResult == IDCANCEL) {
			return;
		}
	}
	CMainFrame* pFrame = (CMainFrame*)AfxGetMainWnd();
	pFrame->LockTabUpdate();
	for (int i = pTabs->count - 1; i > m_ClickedTab; i--) {
		pTabs->pView[i]->PostMessage( WM_COMMAND, ID_FILE_CLOSE );
	}
	for (int j = 0; j < m_ClickedTab; j++) {
		pTabs->pView[0]->SendMessage( WM_COMMAND, ID_FILE_CLOSE );
	}
	pFrame->UnlockTabUpdate();
}

/// ̃^u荶
void CPatriotTabbar::OnFileCloseleft()
{
	if (g_Options.bAlertCloseExcept) {
		int nResult = AfxMessageBox( _T("̃^u荶܂B"), MB_OKCANCEL | MB_ICONQUESTION, 0);
		if (nResult == IDCANCEL) {
			return;
		}
	}

	CMainFrame* pFrame = (CMainFrame*)AfxGetMainWnd();
	pFrame->LockTabUpdate();
	for (int i = 0; i < m_ClickedTab; i++) {
		pTabs->pView[0]->SendMessage( WM_COMMAND, ID_FILE_CLOSE );
	}
	pFrame->UnlockTabUpdate();
}

/// ̃^uE
void CPatriotTabbar::OnFileCloseright()
{
	if (g_Options.bAlertCloseExcept) {
		int nResult = AfxMessageBox( _T("̃^uE܂B"), MB_OKCANCEL | MB_ICONQUESTION, 0);
		if (nResult == IDCANCEL) {
			return;
		}
	}

	CMainFrame* pFrame = (CMainFrame*)AfxGetMainWnd();
	pFrame->LockTabUpdate();
	for (int i = pTabs->count - 1; i > m_ClickedTab; i--) {
		pTabs->pView[i]->PostMessage( WM_COMMAND, ID_FILE_CLOSE );
	}
	pFrame->UnlockTabUpdate();
}
