// PageFilter.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "optiondlg.h"
#include "PageFilter.h"
#include "../DlgFilter.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CPageFilter vpeB y[W

IMPLEMENT_DYNCREATE(CPageFilter, CPropertyPage)

CPageFilter::CPageFilter()
	: CPropertyPage(CPageFilter::IDD)
	, m_List1()
{
	//{{AFX_DATA_INIT(CPageFilter)
	m_UseFirst = FALSE;
	//}}AFX_DATA_INIT
}

CPageFilter::~CPageFilter()
{
}

void CPageFilter::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPageFilter)
	DDX_Control(pDX, IDC_LIST1, m_List1);
	DDX_Check(pDX, IDC_CHECK2, m_UseFirst);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CPageFilter, CPropertyPage)
	//{{AFX_MSG_MAP(CPageFilter)
	ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
	ON_BN_CLICKED(IDC_BUTTON2, OnButton2)
	ON_BN_CLICKED(IDC_BUTTON3, OnButton3)
	ON_BN_CLICKED(IDC_BUTTON4, OnButton4)
	ON_BN_CLICKED(IDC_BUTTON5, OnButton5)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPageFilter bZ[W nh

BOOL CPageFilter::OnInitDialog()
{
	CPropertyPage::OnInitDialog();

	m_UseFirst = g_Options.FilterUseFirst;

	Filters.LoadData( g_Options.strOptionPath + _T("\\filter.dat") );
	for (int i = 0;i<Filters.count;i++) {
		 m_List1.AddString(Filters.pWebFilter[i].strUrl);
	}

	UpdateData(FALSE);
	return TRUE;  // Rg[ɃtH[JXݒ肵ȂƂA߂l TRUE ƂȂ܂
				  // O: OCX vpeB y[W̖߂l FALSE ƂȂ܂
}

void CPageFilter::OnOK()
{ // ݒۑ
	g_Options.FilterUseFirst = m_UseFirst;

	Filters.SaveData( g_Options.strOptionPath + _T("\\filter.dat") );
	CPropertyPage::OnOK();
}

void CPageFilter::OnButton1()
{ // ǉ
	CDlgFilter dlg;
	if (dlg.DoModal() == IDOK) {
		Filters.Add(dlg.m_Filter , Filters.count);
		m_List1.AddString(dlg.m_Url);
		m_List1.SetCurSel(m_List1.GetCount()-1);
	}
}

void CPageFilter::OnButton2()
{ // ҏW
	CDlgFilter dlg;
	int i = m_List1.GetCurSel();
	if (i < 0)
		return;

	dlg.m_Url		=Filters.pWebFilter[i].strUrl;
	dlg.m_Proxy 	=Filters.pWebFilter[i].strProxy;

	dlg.m_Image 	=Filters.pWebFilter[i].bImage;
	dlg.m_Bgm		=Filters.pWebFilter[i].bBgm;
	dlg.m_Video 	=Filters.pWebFilter[i].bVideo;

	dlg.m_Script	=Filters.pWebFilter[i].bScript;
	dlg.m_Java		=Filters.pWebFilter[i].bJava;
	dlg.m_ActiveX	=Filters.pWebFilter[i].bActiveX;
	dlg.m_ActiveX2	=Filters.pWebFilter[i].bActiveX2;

	dlg.m_AntiPopup =Filters.pWebFilter[i].bAntiPopup;
	dlg.m_Silent	=Filters.pWebFilter[i].bSilent;
	dlg.m_TabLock	=Filters.pWebFilter[i].bTabLock;
	dlg.m_ShiftLock =Filters.pWebFilter[i].bShiftLock;

	dlg.m_Cookie	=Filters.pWebFilter[i].bCookie;
	dlg.m_Cookie2	=Filters.pWebFilter[i].bCookie2;

	if (dlg.DoModal() == IDOK) {
		Filters.Delete(i);
		Filters.Add(dlg.m_Filter , i);
		m_List1.DeleteString(i);
		m_List1.InsertString(i , dlg.m_Url);
		m_List1.SetCurSel(i);
	}
}

void CPageFilter::OnButton3()
{ // 폜
	if (m_List1.GetCurSel() < 0)  return;
	int Index = m_List1.GetCurSel();
	Filters.Delete(Index);
	m_List1.DeleteString(Index);

	if (Index < m_List1.GetCount())
		m_List1.SetCurSel(Index);
	else
		m_List1.SetCurSel(m_List1.GetCount()-1);
	m_List1.SetFocus();
}

void CPageFilter::OnButton4()
{ // 
	int i = m_List1.GetCurSel();
	if (i <= 0)
		return;
	WebFilter bufFilter = Filters.pWebFilter[i];
	Filters.pWebFilter[i]=Filters.pWebFilter[i-1];
	Filters.pWebFilter[i-1]=bufFilter;

	CString str;
	m_List1.GetText(i , str);
	m_List1.DeleteString(i);
	m_List1.InsertString(i-1 , str);
	m_List1.SetCurSel(i-1);
}

void CPageFilter::OnButton5()
{ // 
	int i = m_List1.GetCurSel();
	if (i>=m_List1.GetCount()-1)
		return;
	WebFilter bufFilter = Filters.pWebFilter[i];
	Filters.pWebFilter[i]=Filters.pWebFilter[i+1];
	Filters.pWebFilter[i+1]=bufFilter;

	CString str;
	m_List1.GetText(i , str);
	m_List1.DeleteString(i);
	m_List1.InsertString(i+1 , str);
	m_List1.SetCurSel(i+1);
}

